function BodyParts() {
}


BodyParts.getName = function(type, name) {
    if(type == "head") {
        return Mob.types[BodyParts.heads[name].type].name + "&nbsp; Head";
    } else if(type == "body") {
        return Mob.types[BodyParts.bodies[name].type].name + "&nbsp; Body";
    } else if(type == "arms") {
        return Mob.types[BodyParts.arms[name].type].name + "&nbsp; Arms";
    } else if(type == "legs") {
        return Mob.types[BodyParts.legs[name].type].name + "&nbsp; Legs";
    }
    return "";
};


BodyParts.getNotice = function(type, name) {
    var notice = "You&nbsp; found&nbsp; ";
    if(type == "head") {
        if("name" == "ent") {
            notice += "an&nbsp; ";
        } else {
            notice += "a&nbsp; ";
        }
        notice += Mob.types[BodyParts.heads[name].type].name + "&nbsp; Head";
    } else if(type == "body") {
        if("name" == "ent") {
            notice += "an&nbsp; ";
        } else {
            notice += "a&nbsp; ";
        }
        notice += Mob.types[BodyParts.bodies[name].type].name + "&nbsp; Body";
    } else if(type == "arms") {
        notice += Mob.types[BodyParts.arms[name].type].name + "&nbsp; Arms";
    } else if(type == "legs") {
        notice += Mob.types[BodyParts.legs[name].type].name + "&nbsp; Legs";
    }
    return notice;
};


BodyParts.getDescription = function(type, name) {

    var typeO = null;
    var desc = "";

    if(type == "head") {
        typeO = BodyParts.heads[name];
        desc += Mob.types[typeO.type].names + "&nbsp; won't&nbsp; attack&nbsp; you.<br /><br />";
        if(typeO.hasOwnProperty("second")) {

        }

    } else if(type == "body") {
        typeO = BodyParts.bodies[name];

    } else if(type == "arms") {
        typeO = BodyParts.arms[name];
        desc += "Attack<br />Damage:&nbsp; " + typeO.attackStrength.toFixed(0) + "<br />";
        desc += "Cooldown:&nbsp; " + typeO.attackLength.toFixed(1) + "&nbsp; Seconds<br />";
        desc += "Range:&nbsp; " + (typeO.attackRange / 20).toFixed(0) + "<br /><br />";
        if(typeO.hasOwnProperty("knockback")) {
            desc += "Knockback&nbsp; " + typeO.knockback.toFixed(0) + "<br /><br />";
        }
        if(typeO.hasOwnProperty("dot")) {
            desc += "Poison&nbsp; " + (typeO.dot[0] - 1).toFixed(0) + "<br /><br />";
        }
        if(typeO.hasOwnProperty("stun")) {
            desc += "Freezing&nbsp; " + typeO.stun.toFixed(0) + "<br /><br />";
        }

    } else if(type == "legs") {
        typeO = BodyParts.legs[name];
        desc += "Speed:&nbsp; " + typeO.speed.toFixed(0) + "<br /><br />";

    }
    if(typeO.hasOwnProperty("life")) {
        desc += "+&nbsp; " + typeO.life.toFixed(0) + "&nbsp; life.<br /><br />";
    }
    if(typeO.hasOwnProperty("defense")) {
        desc += "+&nbsp; " + typeO.defense.toFixed(0) + "&nbsp; defense.<br /><br />";
    }
    return desc;
};


BodyParts.heads = {

    human_w_m : {
        type : "human",
        offset : 0,
        height: 10,
    },

    human_b_m : {
        type : "human",
        offset : 1,
        height: 10,
    },

    human_w_f : {
        type : "human",
        offset : 2,
        height: 10,
    },

    human_b_f : {
        type : "human",
        offset : 3,
        height: 10,
    },

    slime_0 : {
        type : "slime",
        offset : 4,
        height: 10,
        //second : [3, 3.0, 10.0]
    },

    slime_1 : {
        type : "slime",
        offset : 5,
        height: 10,
        //second : [3, 3.0, 10.0]
    },

    slime_2 : {
        type : "slime",
        offset : 6,
        height : 10,
        //second : [3, 3.0, 10.0]
    },

    zombie_0 : {
        type : "zombie",
        offset : 7,
        height : 10,
        life : 30,
    },

    zombie_1 : {
        type : "zombie",
        offset : 8,
        height: 10,
        life : 30,
    },

    skeleton : {
        type : "skeleton",
        offset : 9,
        height: 10,
    },

    lindworm : {
        type : "lindworm",
        offset : 10,
        height : 16,
        defence : 1,
        life: 600,
        //second : [4, 3.0, 5.0]
    },

    goblin : {
        type : "goblin",
        offset : 11,
        height : 12,
    },

    yeti : {
        type : "yeti",
        offset : 12,
        height : 12,
        defence : 1,
    },

    ent : {
        type : "ent",
        offset : 13,
        height : 20,
        //second : [1, 1.0, 10.0]
    },

    walker : {
        type : "walker",
        offset : 14,
        height : 12,
        defence : 1,
        //second : [2, 3.0, 6.0]
    },

    golem : {
        type : "golem",
        offset : 15,
        height: 14,
        defence: 2,
    },

    demon : {
        type : "demon",
        offset : 16,
        height : 14,
        defence: 1,
    },

    minotaur : {
        type : "minotaur",
        offset : 17,
        height : 18
    },
};


BodyParts.bodies = {

    human_0 : {
        type : "human",
        offset : 0,
        height : 12,
        headX : 0.0,
        headD : 1.0,
        armsH : 2.0,
        armsX : 6.0,
        armsD : 2.0,
        shadowSize : 1,
        life : 10,
        defence : 1,
    },

    human_1 : {
        type : "human",
        offset : 1,
        height : 12,
        headX : 0.0,
        headD : 1.0,
        armsH : 2.0,
        armsX : 6.0,
        armsD : 2.0,
        shadowSize : 1,
        life : 10,
        defence : 1,
    },

    human_2: {
        type : "human",
        offset : 2,
        height : 12,
        headX : 0.0,
        headD : 1.0,
        armsH : 2.0,
        armsX : 6.0,
        armsD : 2.0,
        shadowSize : 1,
        life : 10,
        defence : 1,
    },

    human_3 : {
        type : "human",
        offset : 3,
        height : 12,
        headX : 0.0,
        headD : 1.0,
        armsH : 2.0,
        armsX : 6.0,
        armsD : 2.0,
        shadowSize : 1,
        life : 10,
        defence : 1,
    },

    slime_0 : {
        type : "slime",
        offset : 4,
        height : 14,
        headX : 0.0,
        headD : 2.0,
        armsH : 4.0,
        armsX : 10.0,
        armsD : 4.0,
        shadowSize : 2,
        life : 250,
    },

    slime_1 : {
        type : "slime",
        offset : 5,
        height : 14,
        headX : 0.0,
        headD : 2.0,
        armsH : 4.0,
        armsX : 10.0,
        armsD : 4.0,
        shadowSize : 2,
        life : 250,
    },

    slime_2 : {
        type : "slime",
        offset : 6,
        height : 14,
        headX : 0.0,
        headD : 2.0,
        armsH : 4.0,
        armsX : 10.0,
        armsD : 4.0,
        shadowSize : 2,
        life : 250,
    },

    zombie_0 : {
        type : "zombie",
        offset : 7,
        height : 12,
        headX : 2.0,
        headD : 1.0,
        armsH : 8.0,
        armsX : 3.0,
        armsD : 8.0,
        shadowSize : 1,
        life : 100,
    },

    zombie_1 : {
        type : "zombie",
        offset : 8,
        height : 12,
        headX : 0.0,
        headD : 2.0,
        armsH : 8.0,
        armsX : 3.0,
        armsD : 8.0,
        shadowSize : 1,
        life : 100,
    },

    skeleton : {
        type : "skeleton",
        offset : 9,
        height : 12,
        headX : 0.0,
        headD : 1.0,
        armsH : 4.0,
        armsX : 6.0,
        armsD : 4.0,
        shadowSize : 1,
        life : 60,
    },

    lindworm : {
        type : "lindworm",
        offset : 10,
        height : 30,
        headX : 0.0,
        headD : 34.0,
        armsH : 16.0,
        armsX : 14.0,
        armsD : 2.0,
        shadowSize : 4,
        life : 1200,
        defense : 4,
    },

    goblin : {
        type : "goblin",
        offset : 11,
        height : 10,
        headX : 0.0,
        headD : 1.0,
        armsH : 2.0,
        armsX : 6.0,
        armsD : 4.0,
        shadowSize : 1,
        life : 12,
    },

    yeti : {
        type : "yeti",
        offset : 12,
        height : 12,
        headX : 0.0,
        headD : 6.0,
        armsH : 4.0,
        armsX : 8.0,
        armsD : 8.0,
        shadowSize : 2,
        life : 36,
        defense : 1,
    },

    ent : {
        type : "ent",
        offset : 13,
        height : 18,
        headX : 0.0,
        headD : 6.0,
        armsH : 2.0,
        armsX : 8.0,
        armsD : 2.0,
        shadowSize : 2,
        life : 24,
        defense : 2,
    },

    walker : {
        type : "walker",
        offset : 14,
        height : 20,
        headX : 0.0,
        headD : 1.0,
        armsH : 6.0,
        armsX : 6.0,
        armsD : 2.0,
        shadowSize : 1,
        life : 50,
    },

    golem : {
        type : "golem",
        offset : 15,
        height : 24,
        headX : 0.0,
        headD : 1.0,
        armsH : 6.0,
        armsX : 14.0,
        armsD : 2.0,
        shadowSize : 3,
        life : 200,
        defense : 4,
    },

    demon : {
        type : "demon",
        offset : 16,
        height : 22,
        headX : 0.0,
        headD : 1.0,
        armsH : 6.0,
        armsX : 9.0,
        armsD : 2.0,
        shadowSize : 2,
        life : 480,
        defense : 1,
    },

    minotaur : {
        type : "minotaur",
        offset : 17,
        height : 12,
        headX : 0.0,
        headD : 2.0,
        armsH : 2.0,
        armsX : 10.0,
        armsD : 2.0,
        shadowSize : 3,
        life : 320,
        defense : 1,
    },
};


BodyParts.arms = {

    human_w : {
        type : "human",
        offset : 0,
        oneArmAttack : true,
        attackLength : 0.2,
        attackStrength : 5.0,
        attackRange : 40,
        hitSize : 4,
    },

    human_b : {
        type : "human",
        offset : 1,
        oneArmAttack : true,
        attackLength : 0.2,
        attackStrength : 5.0,
        attackRange : 40,
        hitSize : 4,
    },

    slime_0 : {
        type : "slime",
        offset : 2,
        oneArmAttack : false,
        attackLength : 0.2,
        attackStrength : 25.0,
        attackRange : 60,
        hitSize : 5,
    },

    slime_1 : {
        type : "slime",
        offset : 3,
        oneArmAttack : false,
        attackLength : 0.2,
        attackStrength : 25.0,
        attackRange : 60,
        hitSize : 5,
    },

    slime_2 : {
        type : "slime",
        offset : 4,
        oneArmAttack : false,
        attackLength : 0.2,
        attackStrength : 25.0,
        attackRange : 60,
        dot : [3.0, 30.0],
        hitSize : 5,
    },

    zombie : {
        type : "zombie",
        offset : 5,
        oneArmAttack : false,
        attackLength : 0.5,
        attackStrength : 50.0,
        attackRange : 40,
        dot : [2.0, 20.0],
        hitSize : 6,
    },

    skeleton : {
        type : "skeleton",
        offset : 6,
        oneArmAttack : true,
        attackLength : 0.5,
        attackStrength : 25.0,
        attackRange : 40,
        hitSize : 6,
    },

    lindworm : {
        type : "lindworm",
        offset : 7,
        oneArmAttack : false,
        attackLength : 1.0,
        attackStrength : 2000.0,
        attackRange : 120,
        hitSize : 10,
        defence: 1,
        knockback: 2.0,
        life: 400,
    },

    goblin : {
        type : "goblin",
        offset : 8,
        oneArmAttack : true,
        attackLength : 0.2,
        attackStrength : 6.0,
        attackRange : 50,
        hitSize : 4,
    },

    yeti : {
        type : "yeti",
        offset : 9,
        oneArmAttack : false,
        attackLength : 0.3,
        attackStrength : 12.0,
        attackRange : 60,
        stun : 1,
        hitSize : 5,
    },

    ent : {
        type : "ent",
        offset : 10,
        oneArmAttack : false,
        attackLength : 1.0,
        attackStrength : 30.0,
        attackRange : 80,
        knockback : 2.0,
        hitSize : 6,
    },

    walker : {
        type : "walker",
        offset : 11,
        oneArmAttack : true,
        attackLength : 0.5,
        attackStrength : 25.0,
        attackRange : 60,
        hitSize : 6,
        stun : 1,
    },

    golem : {
        type : "golem",
        offset : 12,
        oneArmAttack : false,
        attackLength : 1.0,
        attackStrength : 160.0,
        attackRange : 100,
        stun : 2,
        knockback : 4.0,
        hitSize : 8,
    },

    demon : {
        type : "demon",
        offset : 13,
        oneArmAttack : false,
        attackLength : 0.3,
        attackStrength : 160.0,
        attackRange : 80,
        knockback : 1.0,
        hitSize : 8,
    },

    minotaur : {
        type : "minotaur",
        offset : 14,
        oneArmAttack : false,
        attackLength : 0.5,
        attackStrength : 128.0,
        attackRange : 60,
        stun : 1,
        hitSize : 7,
    },

};


BodyParts.legs = {

    human_0 : {
        type : "human",
        offset : 0,
        height: 4.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 80,
    },

    human_1 : {
        type : "human",
        offset : 1,
        height: 4.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 80,
    },

    slime_0 : {
        type : "slime",
        offset : 2,
        height: 5.0,
        x : 6.0,
        d : 0.0,
        shadowSize : 2,
        speed : 30,
    },

    slime_1 : {
        type : "slime",
        offset : 3,
        height: 5.0,
        x : 6.0,
        d : 0.0,
        shadowSize : 2,
        speed : 30,
    },

    slime_2 : {
        type : "slime",
        offset : 4,
        height: 5.0,
        x : 6.0,
        d : 0.0,
        shadowSize : 2,
        speed : 30,
    },

    zombie : {
        type : "zombie",
        offset : 5,
        height: 4.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 40,
    },

    skeleton : {
        type : "skeleton",
        offset : 6,
        height: 4.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 80,
        life : 12
    },

    lindworm : {
        type : "lindworm",
        offset : 7,
        height: 10.0,
        x : 9.0,
        d : -4.0,
        shadowSize : 3,
        speed : 120,
        life: 400,
    },

    goblin : {
        type : "goblin",
        offset : 8,
        height: 3.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 70,
    },

    yeti : {
        type : "yeti",
        offset : 9,
        height: 6.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 2,
        speed : 80,
    },

    ent : {
        type : "ent",
        offset : 10,
        height: 8.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 2,
        speed : 20,
        life : 16,
    },

    walker : {
        type : "walker",
        offset : 11,
        height: 5.0,
        x : 3.0,
        d : 0.0,
        shadowSize : 1,
        speed : 30,
        life : 12,
    },

    golem : {
        type : "golem",
        offset : 12,
        height: 10.0,
        x : 6.0,
        d : 0.0,
        shadowSize : 2,
        speed : 40,
        life : 50,
    },

    demon : {
        type : "demon",
        offset : 13,
        height: 10.0,
        x : 5.0,
        d : 0.0,
        shadowSize : 1,
        speed : 100,
    },

    minotaur : {
        type : "minotaur",
        offset : 14,
        height: 6.0,
        x : 5.0,
        d : 0.0,
        shadowSize : 2,
        speed : 60,
    },

};