function Camera() {

    this.OFFSET_X = 450;
    this.OFFSET_Y = 320;

    this.LAG = 25;

    this.historyX = [];
    this.historyY = [];

    this.x = 0;
    this.y = 0;

    this.init = function() {
        this.addPoint();
    };


    this.update = function() {
        this.addPoint();
        this.x = 0;
        this.y = 0;
        var counter = 0;
        for(var i = 0; i < this.historyX.length; i++) {
            this.x += this.historyX[i];
            this.y += this.historyY[i];
            counter++;
        }
        this.x = Math.round(this.x / counter);
        this.y = Math.round(this.y / counter);
    };


    this.addPoint = function() {
        var x = player.x;
        var y = player.y;
        x = limit(x, this.OFFSET_X + 40, (map.W * map.TILE_W - (game.WIDTH - this.OFFSET_X)) - 40);
        y = limit(y, this.OFFSET_Y + 40, (map.H * map.TILE_H - (game.HEIGHT - this.OFFSET_Y)) - 40);
        this.historyX.push(x);
        this.historyY.push(y);
        if(this.historyX.length >= this.LAG) {
            this.historyX.shift();
            this.historyY.shift();
        }
    };


    this.translate = function() {
        c.save();
        c.translate(this.OFFSET_X - this.x, this.OFFSET_Y - this.y);
    };


    this.restore = function() {
        c.restore();
    };


    this.getLimits = function() {
        return {
            x1 : this.x - this.OFFSET_X,
            x2 : this.x + (game.WIDTH - this.OFFSET_X),
            y1 : this.y - this.OFFSET_Y,
            y2 : this.y + (game.HEIGHT - this.OFFSET_Y),
        }
    };

};