function MapGenerator() {
}


MapGenerator.generate = function() {

    for(var x = 0; x < map.W; x++) {

        var type = limit(Math.floor((x - 24) / 40), 0, 6);
        var typeOffset = (x - 24) - (type * 40);
        var end = typeOffset - 32;

        for(var y = 0; y < map.H; y++) {
            var tileType = type;
            if(end >= 0 && type < 6) {
                if(rand(0, 7) >= 7 - end) {
                    tileType++;
                }
            }
            MapGenerator.setTile(x, y, (tileType * 8) + 4 + rand(0, 3));
            map.t[x][y].elevation = limit(rand(0, 6), 5, 6);
        }
    }

    var pathPs = [];
    var areaPathPs = [];
    for(var area = 0; area <= 6; area++) {
        areaPathPs[area] = [];
    }

    for(var area = 0; area <= 6; area++) {

        var numOfOpenings = 1;
        if(area > 0 && area < 6) {
            numOfOpenings = rand(3, 4);
        }
        numOfOpenings--;
        for(var open = 50 - (10 * numOfOpenings); open <= 50 + (10 * numOfOpenings); open += 20) {
            var radius = 14;
            if(area > 0 && area < 6) {
                radius = rand(14, 16) - numOfOpenings;
            }
            MapGenerator.createOpening(40 + 40 * area, open, radius, rand(2, 3));
        }

        if(area < 6) {
            var numOfPassages = 1;
            if(area > 0 && area < 5) {
                numOfPassages = rand(2, 3);
            }
            numOfPassages--;
            for(var pass = 50 - (15 * numOfPassages); pass <= 50 + (15 * numOfPassages); pass += rand(20, 30)) {
                for(var i = 50; i < 80; i += 4) {
                    MapGenerator.createOpening(i + (40 * area), pass, rand(3, 5), 1);
                }
                var startPath = 40;
                if(area > 0) {
                    startPath = (area * 40) + rand(35, 45);
                }
                var endPath = ((area + 1) * 40) + rand(35, 45);
                var lastPathP = { x : 40, y : 50 };
                if(area > 0) {
                    var lastPathP = { x : startPath + rand(-2, 2), y : pass + rand(-2, 2) };
                }
                areaPathPs[area].push(lastPathP);
                var nextPathP;
                for(var i = startPath + 4; i <= endPath + 2 && i < 272; i += rand(3, 6)) {
                    nextPathP = { x : i + rand(-2, 2), y : pass + rand(-2, 2) };
                    pathPs.push([
                        lastPathP,
                        nextPathP,
                    ]);
                    lastPathP = nextPathP;
                }
                areaPathPs[area + 1].push(lastPathP);
            }
        }

        var numOfHills = 6;
        if(area > 0 && area < 6) {
            numOfHills = 9;
        }
        while(numOfHills > 0) {
            var hillX = 40 + (area * 40) + rand(-15, 15);
            var hillY = rand(10, 90);
            if(map.t[hillX][hillY].elevation < 5) {
                if(numOfHills <= 2) {
                    MapGenerator.addHill(hillX, hillY, rand(2, 4), 0, area, rand(1, 2));
                } else {
                    if(area <= 3) {
                        MapGenerator.addHill(hillX, hillY, 1, 0, 3, rand(2, 3));
                    } else {
                        MapGenerator.addHill(hillX, hillY, rand(1, 2), 0, 5, rand(2, 3));
                    }
                }
                numOfHills--;
            }
        }

        var numOfRocks = 20;
        while(numOfRocks > 0) {
            var rockX = 40 + (area * 40) + rand(-19, 19);
            var rockY = rand(10, 90);
            if(area == 0) {
                MapGenerator.addRock(rockX, rockY, 0, 3);
            } else if(area <= 3) {
                MapGenerator.addRock(rockX, rockY, 1, 3);
            } else {
                MapGenerator.addRock(rockX, rockY, 1, 5);
            }
            numOfRocks--;
        }

        var numOfLakes = 2;
        if(area > 0) {
            numOfLakes = 5;
        }
        while(numOfLakes > 0) {
            var lakeX = 40 + (area * 40) + rand(-15, 15);
            var lakeY = rand(10, 90);
            if(map.t[lakeX][lakeY].elevation <= 1) {
                if(area <= 1) {
                    MapGenerator.addLake(lakeX, lakeY, rand(1, 2), 1, false);
                } else if(area == 2) {
                    MapGenerator.addLake(lakeX, lakeY, rand(1, 2), 1, true);
                } else if(area <= 4) {
                    MapGenerator.addLake(lakeX, lakeY, rand(1, 2), 2, false);
                } else {
                    MapGenerator.addLake(lakeX, lakeY, rand(1, 2), 3, false);
                }
                numOfLakes--;
            }
        }
    }

    for(var area = 0; area < 6; area++) {
        var northPathY = 100;
        var northPathIndex = -1;
        for(var i = 0; i < areaPathPs[area].length; i++) {
            if(areaPathPs[area][i].y < northPathY) {
                northPathY = areaPathPs[area][i].y;
                northPathIndex = i;
            }
        }
        var northP = areaPathPs[area][northPathIndex];
        areaPathPs[area].splice(northPathIndex, 1);
        while(areaPathPs[area].length > 0) {
            var southPathY = 100;
            var southPathIndex = -1;
            for(var i = 0; i < areaPathPs[area].length; i++) {
                if(areaPathPs[area][i].y < southPathY) {
                    southPathY = areaPathPs[area][i].y;
                    southPathIndex = i;
                }
            }
            var southP = areaPathPs[area][southPathIndex];
            areaPathPs[area].splice(southPathIndex, 1);
            while(northP.y + 5 < southP.y) {
                var intermediate = { x : northP.x, y : northP.y + rand(3, 5) };
                intermediate.x += Math.round((intermediate.y - northP.y) * (southP.x - northP.x) / (southP.y - northP.y));
                intermediate.x += rand(-3, 3);
                pathPs.push([
                    northP,
                    intermediate,
                ]);
                northP = intermediate;
            }
            pathPs.push([
                northP,
                southP,
            ]);
            northP = southP;
        }
    }

    for(var i = 0; i < pathPs.length; i++) {
        var start = pathPs[i][0];
        var end = pathPs[i][1];
        var pathFinding = new PathFinding();
        var path = pathFinding.find(start, end, 6, function(x, y) {
            return true;
        });
        MapGenerator.setPath(start.x, start.y);
        for(var j = 0; j < path.length; j++) {
            MapGenerator.setPath(path[j].x, path[j].y);
        }
    }

    for(var x = 0; x < map.W; x++) {
        for(var y = 0; y < map.H; y++) {
            if(map.t[x][y].path != 0) {
                var pathCode = 0;
                for(var i = 0; i < 6; i++) {
                    var neighbor = map.getTileNeighbor(x, y, i);
                    if(map.t[neighbor.x][neighbor.y].path != 0) {
                        pathCode += Math.pow(2, i);
                    }
                }
                map.t[x][y].path = pathCode;
            }
        }
    }

    for(var area = 0; area <= 0; area++) {
        var x1 = 21 + (area * 40);
        var x2 = x1 + 38;
        var o1 = (area * 4);
        var o2 = o1;
        MapGenerator.placeObjects(x1, x2, 0, 99, o1, o2, 200, 6);
    }
    MapGenerator.placeObjects(30, 50, 40, 60, 32, 32, 10, 1);
};


MapGenerator.placeObjects = function(x1, x2, y1, y2, o1, o2, num, maxHeight) {
    for(var i = 0; i < num; i++) {
        var x = rand(x1, x2);
        var y = rand(y1, y2);
        var o = rand(o1, o2);
        var t = map.t[x][y];
        if(t.liquid == 0 && t.path == 0 && t.object == -1 && t.elevation <= maxHeight) {
            t.object = o;
            var tileCenter = map.getTilePos(x, y);
            var mobTile = map.getMobTile(tileCenter.x, tileCenter.y);
            map.mobGrid[mobTile.x][mobTile.y] = -1;
            if(o == 32) {
                map.mobGrid[mobTile.x - 1][mobTile.y - 2] = -1;
                map.mobGrid[mobTile.x][mobTile.y - 2] = -1;
                map.mobGrid[mobTile.x + 1][mobTile.y - 2] = -1;
                map.mobGrid[mobTile.x - 1][mobTile.y - 1] = -1;
                map.mobGrid[mobTile.x][mobTile.y - 1] = -1;
                map.mobGrid[mobTile.x + 1][mobTile.y - 1] = -1;
                map.mobGrid[mobTile.x - 1][mobTile.y] = -1;
                map.mobGrid[mobTile.x + 1][mobTile.y] = -1;
            }
        }
    }
};


MapGenerator.setPath = function(x, y) {
    var t = map.t[x][y];
    t.path = 1;
    if(t.elevation > 1) {
        t.elevation = 1;
    }
    if(t.liquid != 0) {
        t.liquid = 0;
    }
    if(t.tileX >= 4) {
        t.tileX -= 4;
    }
};


MapGenerator.setTile = function(x, y, tile) {
    map.t[x][y].tileX = tile % 8;
    map.t[x][y].tileY = Math.floor(tile / 8);
};


MapGenerator.addLake = function(posX, posY, radius, type, ice) {
    var startX = posX - (radius + 1);
    var endX = posX + (radius + 1);
    var startY = posY - (radius + 1);
    var endY = posY + (radius + 1);

    var possibleFrequencies = [3, 5];
    var frequency = possibleFrequencies[rand(0, 1)];
    var offset = randFloat(0.1, 2.5);

    for(var x = startX; x <= endX; x++) {
        for(var y = startY; y <= endY; y++) {
            var angle1 = offset + (Math.atan2(posX - x, posY - y) * frequency);
            var angle2 = (offset * 3) + (Math.atan2(posX - x, posY - y) * 3);
            var maxDist = radius + (0.2 * Math.sin(angle1)) + (0.5 * Math.sin(angle2));
            var dst = distance(x, y, posX, posY);
            if(dst < maxDist) {
                map.t[x][y].liquid = type;
            }
        }
    }
    if(radius > 1) {
        for(var i = rand(0, 2); i > 0; i--) {
            map.t[posX][posY].liquid = 0;
            map.t[posX][posY].elevation = 0;
            if(ice) {
                map.t[posX][posY].tileX = 0;
                map.t[posX][posY].tileY = 7;
            }
        }
    }
};


MapGenerator.addRock = function(posX, posY, typeX, typeY) {
    var startX = posX - 2;
    var endX = posX + 2;
    var startY = posY - 2;
    var endY = posY + 2;

    var frequency = 3;
    var offset = randFloat(0.1, 2.5);

    for(var x = startX; x <= endX; x++) {
        for(var y = startY; y <= endY; y++) {
            var angle1 = offset + (Math.atan2(posX - x, posY - y) * frequency);
            var angle2 = (offset * 3) + (Math.atan2(posX - x, posY - y) * 3);
            var maxDist = 0.8 + (0.2 * Math.sin(angle1)) + (0.5 * Math.sin(angle2));
            var dst = distance(x, y, posX, posY);
            if(dst < maxDist) {
                MapGenerator.setTile(x, y, (4 * ((2 * typeY) + typeX)) + rand(0, 3));
                map.t[x][y].elevation = rand(5, 6);
            }
        }
    }
};


MapGenerator.addHill = function(posX, posY, radius, typeX, typeY, height) {
    var startX = posX - (radius + 1);
    var endX = posX + (radius + 1);
    var startY = posY - (radius + 1);
    var endY = posY + (radius + 1);

    var possibleFrequencies = [3, 5];
    var frequency = possibleFrequencies[rand(0, 1)];
    var offset = randFloat(0.1, 2.5);

    for(var x = startX; x <= endX; x++) {
        for(var y = startY; y <= endY; y++) {
            var angle1 = offset + (Math.atan2(posX - x, posY - y) * frequency);
            var angle2 = (offset * 3) + (Math.atan2(posX - x, posY - y) * 3);
            var maxDist = radius + (0.5 * Math.sin(angle1)) + (Math.sin(angle2));
            var dst = distance(x, y, posX, posY);
            if(dst < maxDist) {
                MapGenerator.setTile(x, y, (4 * ((2 * typeY) + typeX)) + rand(0, 3));
                map.t[x][y].elevation += Math.round((1.0 - (dst / maxDist)) * height);
                if(map.t[x][y].elevation > 3) {
                    map.t[x][y].elevation = 3;
                }
            }
        }
    }
};


MapGenerator.createOpening = function(posX, posY, radius, amplitude) {

    var startX = posX - (radius + amplitude);
    var endX = posX + (radius + amplitude);
    var startY = posY - (radius + amplitude);
    var endY = posY + (radius + amplitude);

    var possibleFrequencies = [5, 7, 9, 11];
    var frequency = possibleFrequencies[rand(0, 3)];
    var offset = randFloat(0.1, 2.5);

    for(var x = startX; x <= endX; x++) {
        for(var y = startY; y <= endY; y++) {
            var angle1 = offset + (Math.atan2(posX - x, posY - y) * frequency);
            var angle2 = (offset * 3) + (Math.atan2(posX - x, posY - y) * 3);
            var maxDist = radius + (0.5 * amplitude * Math.sin(angle1)) + (0.5 * amplitude * Math.sin(angle2));
            if(distance(x, y, posX, posY) < maxDist) {
                if(map.t[x][y].elevation >= 5) {
                    map.t[x][y].tileX -= 4;
                    map.t[x][y].elevation -= 5;
                }
            }
        }
    }

};


MapGenerator.placeSpawners = function() {
    map.addSpawner(40 + rand(-3, 3), 50 + rand(-3, 3), "human", 400, 16);

    map.addSpawner(80 + rand(-3, 3), 20 + rand(-5, 5), "ent", 300, 3);
    map.addSpawner(80 + rand(-3, 3), 35 + rand(-5, 5), "goblin", 300, 7);
    map.addSpawner(80 + rand(-3, 3), 45 + rand(-5, 5), "ent", 300, 3);
    map.addSpawner(80 + rand(-3, 3), 55 + rand(-5, 5), "goblin", 300, 7);
    map.addSpawner(80 + rand(-3, 3), 65 + rand(-5, 5), "ent", 300, 3);
    map.addSpawner(80 + rand(-3, 3), 80 + rand(-5, 5), "goblin", 300, 7);

    map.addSpawner(120 + rand(-3, 3), 20 + rand(-5, 5), "yeti", 300, 7);
    map.addSpawner(120 + rand(-3, 3), 35 + rand(-5, 5), "walker", 300, 3);
    map.addSpawner(120 + rand(-3, 3), 45 + rand(-5, 5), "yeti", 300, 7);
    map.addSpawner(120 + rand(-3, 3), 55 + rand(-5, 5), "walker", 300, 3);
    map.addSpawner(120 + rand(-3, 3), 65 + rand(-5, 5), "yeti", 300, 7);
    map.addSpawner(120 + rand(-3, 3), 80 + rand(-5, 5), "walker", 300, 3);

    map.addSpawner(160 + rand(-3, 3), 20 + rand(-5, 5), "skeleton", 300, 7);
    map.addSpawner(160 + rand(-3, 3), 35 + rand(-5, 5), "golem", 300, 3);
    map.addSpawner(160 + rand(-3, 3), 45 + rand(-5, 5), "skeleton", 300, 7);
    map.addSpawner(160 + rand(-3, 3), 55 + rand(-5, 5), "golem", 300, 3);
    map.addSpawner(160 + rand(-3, 3), 65 + rand(-5, 5), "skeleton", 300, 7);
    map.addSpawner(160 + rand(-3, 3), 80 + rand(-5, 5), "golem", 300, 3);

    map.addSpawner(200 + rand(-3, 3), 20 + rand(-5, 5), "slime", 300, 3);
    map.addSpawner(200 + rand(-3, 3), 35 + rand(-5, 5), "zombie", 300, 7);
    map.addSpawner(200 + rand(-3, 3), 45 + rand(-5, 5), "slime", 300, 3);
    map.addSpawner(200 + rand(-3, 3), 55 + rand(-5, 5), "zombie", 300, 7);
    map.addSpawner(200 + rand(-3, 3), 65 + rand(-5, 5), "slime", 300, 3);
    map.addSpawner(200 + rand(-3, 3), 80 + rand(-5, 5), "zombie", 300, 7);

    map.addSpawner(240 + rand(-3, 3), 20 + rand(-5, 5), "demon", 300, 3);
    map.addSpawner(240 + rand(-3, 3), 35 + rand(-5, 5), "minotaur", 300, 7);
    map.addSpawner(240 + rand(-3, 3), 45 + rand(-5, 5), "demon", 300, 3);
    map.addSpawner(240 + rand(-3, 3), 55 + rand(-5, 5), "minotaur", 300, 7);
    map.addSpawner(240 + rand(-3, 3), 65 + rand(-5, 5), "demon", 300, 3);
    map.addSpawner(240 + rand(-3, 3), 80 + rand(-5, 5), "minotaur", 300, 7);

    map.addSpawner(280 + rand(-3, 3), 50 + rand(-3, 3), "lindworm", 300, 5);
};


MapGenerator.drawDebug = function() {

    var tileColors = [
        "#36bd24", "#0e260d",
        "#42784c", "#0d1d0d",
        "#c0cec4", "#1f211f",
        "#6b6e69", "#151515",
        "#516927", "#101609",
        "#3e3432", "#0a0706",
        "#592e1e", "#000000",
        "#6c6c6c", "#6c6c6c"
    ];

    var debugCanvas = createCanvas((map.W * 2) + 1, map.H * 2);
    var debugC = getContext(debugCanvas);

    debugC.fillStyle = "#000";
    debugC.fillRect(0, 0, (map.W * 2) + 1, map.H * 2);

    var t;

    for(y = 0; y < map.H; y++) {
        for(x = 0; x < map.W; x++) {
            t = map.t[x][y];
            debugC.fillStyle = tileColors[(t.tileY * 2) + Math.floor(t.tileX / 4)];
            debugC.fillRect((x * 2) + (y % 2 == 1 ? 1 : 0), y * 2, 2, 2);
        }
    }

    img.add("debugMap", debugCanvas);
    ImageProcessing.outputImage("debugMap");
};