function MiniMap() {

    this.showing = false;
    this.debug = false;


    this.on = function() {
        keyboard.registerKeyDownHandler(Keyboard.M, function() {
            miniMap.show();
        });
        keyboard.registerKeyUpHandler(Keyboard.M, function() {
            miniMap.hide();
        });
        this.showing = false;
    };


    this.off = function() {
        keyboard.deleteKeyDownHandler(Keyboard.M);
        keyboard.deleteKeyUpHandler(Keyboard.M);
        this.hide();
    };


    this.show = function() {
        if(!this.showing && !game.paused) {
            this.generateMiniMap();
            jQuery("#minimap").show();
            this.showing = true;
        }
    };


    this.hide = function() {
        if(this.showing) {
            jQuery("#minimap").hide();
            this.showing = false;
            if(player.tutorial == 5) {
                player.tutorial = 6;
                panel.hideTutorial();
            }
        }
    };


    this.generateMiniMap = function() {

        var tileColors = [
            "#36bd24", "#0e260d",
            "#42784c", "#0d1d0d",
            "#c0cec4", "#1f211f",
            "#6b6e69", "#151515",
            "#516927", "#101609",
            "#3e3432", "#0a0706",
            "#592e1e", "#000000",
            "#bdebf4", "#6c6c6c"
        ];

        var liquidColors = [
            "#21acc9",
            "#478586",
            "#d21500"
        ];

        var miniMapCanvas = createCanvas((map.W * 2) + 1, map.H * 2);
        var miniMapC = getContext(miniMapCanvas);

        miniMapC.fillStyle = "#000";
        miniMapC.fillRect(0, 0, (map.W * 2) + 1, map.H * 2);

        var t;

        for(y = 0; y < map.H; y++) {
            for(x = 0; x < map.W; x++) {
                t = map.t[x][y];
                if(t.seen || this.debug) {
                    if(t.path != 0) {
                        miniMapC.fillStyle = "#71665c";
                    } else if(t.liquid == 0) {
                        miniMapC.fillStyle = tileColors[(t.tileY * 2) + Math.floor(t.tileX / 4)];
                    } else {
                        miniMapC.fillStyle = liquidColors[t.liquid - 1];
                    }
                    miniMapC.fillRect((x * 2) + (y % 2 == 1 ? 1 : 0), y * 2, 2, 2);
                }
            }
        }

        var playerTilePos = map.coordToTile(player.x, player.y);
        playerTilePos.x *= 2;
        if(playerTilePos.y % 2 == 1) {
            playerTilePos.x++;
        }
        playerTilePos.y *= 2;
        miniMapC.drawImage(img.get("point"), playerTilePos.x - 6, playerTilePos.y - 6);

        jQuery("#minimap img").attr("src", miniMapCanvas.toDataURL("image/png"));
    };
}