function Panel() {

    this.NOTICE_ITEM_X = 314;
    this.NOTICE_ITEM_Y = 32;

    this.points = 0;

    this.spaceCountdown = 0.0;
    this.xCountdown = 0.0;

    this.showingNotice = false;
    this.noticeAnimation = 0.0;
    this.showingChoice = false;
    this.noticeLocationX = 0;
    this.noticeLocationY = 0;
    this.choiceButton = 0;
    this.choiceLoc = "";
    this.choicePart = "";


    this.init = function() {
    };


    this.showTutorial = function(text) {
        jQuery("#tutorial").html(text).show();
    };


    this.hideTutorial = function() {
        jQuery("#tutorial").fadeOut(3000);
    };



    this.showNotice = function() {
        if(this.showingNotice) {
            this.hideNotice();
        }
        this.showingNotice = true;
        this.noticeAnimation = 1.0;
        jQuery("#notice_message").html(BodyParts.getNotice(this.choiceLoc, this.choicePart));
        keyboard.registerKeyUpHandler(Keyboard.ENTER, function() {
            panel.hideNotice();
            panel.showChoice();
        });
    };


    this.hideNotice = function() {
        this.showingNotice = false;
        this.noticeAnimation = 0.0;
        jQuery("#notice").hide();
        keyboard.deleteKeyUpHandler(Keyboard.ENTER);
    };


    this.showChoice = function() {

        game.paused = true;
        this.showingChoice = true;
        this.choiceButton = 0;

        if(this.choiceLoc == "head") {
            jQuery("#choice_1_name").html(BodyParts.getName(this.choiceLoc, player.figure.headName));
            jQuery("#choice_1").html(BodyParts.getDescription(this.choiceLoc, player.figure.headName));
        } else if(this.choiceLoc == "body") {
            jQuery("#choice_1_name").html(BodyParts.getName(this.choiceLoc, player.figure.bodyName));
            jQuery("#choice_1").html(BodyParts.getDescription(this.choiceLoc, player.figure.bodyName));
        } else if(this.choiceLoc == "arms") {
            jQuery("#choice_1_name").html(BodyParts.getName(this.choiceLoc, player.figure.armsName));
            jQuery("#choice_1").html(BodyParts.getDescription(this.choiceLoc, player.figure.armsName));
        } else if(this.choiceLoc == "legs") {
            jQuery("#choice_1_name").html(BodyParts.getName(this.choiceLoc, player.figure.legsName));
            jQuery("#choice_1").html(BodyParts.getDescription(this.choiceLoc, player.figure.legsName));
        }
        jQuery("#choice_2_name").html(BodyParts.getName(this.choiceLoc, this.choicePart));
        jQuery("#choice_2").html(BodyParts.getDescription(this.choiceLoc, this.choicePart));

        jQuery("#choice").show();
        keyboard.registerKeyDownHandler(Keyboard.ARROW_LEFT, function() {
            panel.choiceButton = 0;
        });
        keyboard.registerKeyDownHandler(Keyboard.ARROW_RIGHT, function() {
            panel.choiceButton = 1;
        });
        keyboard.registerKeyUpHandler(Keyboard.ENTER, function() {
            panel.closeChoice();
        });
    };


    this.closeChoice = function() {
        if(this.choiceButton == 1) {
            player.setBodyPart(this.choiceLoc, this.choicePart);
        }
        this.hideChoice();
    };


    this.hideChoice = function() {
        game.paused = false;
        jQuery("#choice").hide();
        this.showingChoice = false;
        keyboard.deleteKeyDownHandler(Keyboard.ARROW_LEFT);
        keyboard.deleteKeyDownHandler(Keyboard.ARROW_RIGHT);
        keyboard.deleteKeyUpHandler(Keyboard.ENTER);
    };


    this.update = function() {
        if(this.points < player.points) {
            var increase = Math.floor(this.points / 200);
            if(increase < 4) {
                increase = 4;
            }
            this.points += increase;
            if(this.points > player.points) {
                this.points = player.points;
            }
            jQuery("#points").html(this.points.toString(10));
        }
        if(this.spaceCountdown > 0.0) {
            this.spaceCountdown -= timer.delta;
            if(this.spaceCountdown < 0.0) {
                this.spaceCountdown = 0.0;
            }
        }
        if(this.xCountdown > 0.0) {
            this.xCountdown -= timer.delta;
            if(this.xCountdown < 0.0) {
                this.xCountdown = 0.0;
            }
        }
        if(this.noticeAnimation > 0.0) {
            var fadeInText = false;
            if(this.noticeAnimation > 0.2) {
                fadeInText = true;
            }
            this.noticeAnimation -= 0.75 * timer.delta;
            if(fadeInText && this.noticeAnimation < 0.2) {
                jQuery("#notice").fadeIn(267);
            }
            if(this.noticeAnimation < 0.0) {
                this.noticeAnimation = 0.0;
            }
        }
    };


    this.drawTimer = function(x, y, countDown) {
        c.save();
        c.translate(x, y);

        countDown = limit(countDown, 0.0, 1.0);
        countDown *= TWO_PI;

        c.beginPath();
        c.moveTo(0, 0);
        if(countDown >= 1.75 * PI) {
            c.lineTo(24 * Math.tan((2.0 * PI) - countDown), -24);
            c.lineTo(24, -24);
            c.lineTo(24, 24);
            c.lineTo(-24, 24);
            c.lineTo(-24, -24);
            c.lineTo(0, -24);
        } else if(countDown >= 1.25 * PI) {
            c.lineTo(24, 24 * Math.tan((1.5 * PI) - countDown));
            c.lineTo(24, 24);
            c.lineTo(-24, 24);
            c.lineTo(-24, -24);
            c.lineTo(0, -24);
        } else if(countDown >= 0.75 * PI) {
            c.lineTo(-24 * Math.tan(PI - countDown), 24);
            c.lineTo(-24, 24);
            c.lineTo(-24, -24);
            c.lineTo(0, -24);
        } else if(countDown >= 0.25 * PI) {
            c.lineTo(-24, -24 * Math.tan((0.5 * PI) - countDown));
            c.lineTo(-24, -24);
            c.lineTo(0, -24);
        } else  {
            c.lineTo(24 * Math.tan(-countDown), -24);
            c.lineTo(0, -24);
        }
        c.closePath();
        c.fillStyle = "rgba(0, 0, 0, 0.6)";
        c.fill();

        c.restore();
    };


    this.draw = function() {
        img.draw("panelBL", 0, 360);
        var h = Math.round(98 * (player.life / player.maxLife));
        if(h > 0) {
            c.drawImage(img.get("life"), 0, 98 - h, 100, h, 10, 444 + (98 - h), 100, h);
        }

        var offset = 56;
        if(player.figure.hasSecondAttack()) {
            offset = 0;
        }
        img.draw("attackBar", 760, 450 + offset);

        img.drawSprite("arms", 868 - 25, 512 + offset - 21, 40, 40, 5, player.figure.arms.offset);
        img.drawSprite("arms", 868 - 17, 512 + offset - 17, 40, 40, 5, player.figure.arms.offset);

        img.drawSprite("heads", 868 - 20, 568 + offset - 30, 40, 50, 5, player.figure.head.offset);

        var mainAttackCountdown = player.figure.mainAttackCountdown;
        mainAttackCountdown /= player.figure.arms.attackLength;
        this.drawTimer(868, 512 + offset, mainAttackCountdown);

        if(player.figure.hasSecondAttack()) {
            var secondAttackCountdown = player.figure.secondAttackCountdown;
            secondAttackCountdown /= player.figure.head.second[2];
            this.drawTimer(868, 568 + offset, secondAttackCountdown);
        }

        img.draw("attackBarCover", 760, 450 + offset);

        if(this.spaceCountdown > 0.0) {
            c.globalAlpha = limit(this.spaceCountdown * 2.0, 0.0, 1.0);
            img.drawSprite("attackBarActive", 760, 486 + offset, 140, 56, 0, 0);
            c.globalAlpha = 1.0;
        }
        if(this.xCountdown > 0.0) {
            c.globalAlpha = limit(this.xCountdown * 2.0, 0.0, 1.0);
            img.drawSprite("attackBarActive", 760, 542 + offset, 140, 56, 0, 1);
            c.globalAlpha = 1.0;
        }


        if(this.showingNotice) {
            this.drawNotice();
        }


        if(player.won) {
            img.draw("victory", 0, 0);
        }

        if(game.paused && !player.dead && !this.showingChoice) {
            img.draw("paused", 0, 0);
        }


        if(this.showingChoice) {
            this.drawChoice();
        }
    };


    this.drawNotice = function() {
        var itemX = this.NOTICE_ITEM_X;
        var itemY = this.NOTICE_ITEM_Y;
        if(this.noticeAnimation > 0.2) {
            var itemAni = 1.25 * (this.noticeAnimation - 0.2) * PI
            itemAni = Math.cos(itemAni);
            if(itemAni < 0) {
                itemAni += 1.0;
                itemAni = itemAni * itemAni;
                itemAni = 1.0 - (0.5 * itemAni);
            } else {
                itemAni = 1.0 - itemAni;
                itemAni = itemAni * itemAni
                itemAni = 0.5 * itemAni;
            }
            itemX += (this.noticeLocationX - this.NOTICE_ITEM_X) * itemAni;
            itemY += (this.noticeLocationY - this.NOTICE_ITEM_Y) * itemAni;
        }

        if(this.noticeAnimation < 0.2) {
            c.globalAlpha = limit(1.0 - (this.noticeAnimation * 5.0), 0.0, 1.0);
            img.draw("notice", 230, 0);
            c.globalAlpha = 1.0;
        }

        c.globalAlpha = limit(1.0 - (this.noticeAnimation * 5.0), 0.75, 1.0);
        img.draw("star", itemX - 30, itemY - 30);
        c.globalAlpha = 1.0;

        if(this.choiceLoc == "head") {
            img.drawSprite("heads", itemX - 20, itemY - 34, 40, 50, 5, BodyParts.heads[this.choicePart].offset);

        } else if(this.choiceLoc == "body") {
            img.drawSprite("bodies", itemX - 40, itemY - 54, 80, 80, 5, BodyParts.bodies[this.choicePart].offset);

        } else if(this.choiceLoc == "arms") {
            img.drawSprite("arms", itemX - 25, itemY - 21, 40, 40, 5, BodyParts.arms[this.choicePart].offset);
            img.drawSprite("arms", itemX - 17, itemY - 17, 40, 40, 5, BodyParts.arms[this.choicePart].offset);

        } else if(this.choiceLoc == "legs") {
            img.drawSprite("legs", itemX - 25, itemY - 25, 40, 40, 5, BodyParts.legs[this.choicePart].offset);
            img.drawSprite("legs", itemX - 17, itemY - 21, 40, 40, 5, BodyParts.legs[this.choicePart].offset);

        }
    };


    this.drawChoice = function() {
        img.draw("choice", 0, 0);
        img.drawSprite("choiceButton", 150, 450, 220, 70, 0, this.choiceButton == 0 ? 1 : 0);
        img.drawSprite("choiceButton", 530, 450, 220, 70, 1, this.choiceButton == 1 ? 1 : 0);

        if(this.choiceLoc == "head") {
            img.drawSprite("headsBig", 260 - 40, 140 - 68, 80, 100, 3, player.figure.head.offset);
            img.drawSprite("headsBig", 640 - 40, 140 - 68, 80, 100, 5, BodyParts.heads[this.choicePart].offset);

        } else if(this.choiceLoc == "body") {
            img.drawSprite("bodiesBig", 260 - 80, 140 - 108, 160, 160, 3, player.figure.body.offset);
            img.drawSprite("bodiesBig", 640 - 80, 140 - 108, 160, 160, 5, BodyParts.bodies[this.choicePart].offset);

        } else if(this.choiceLoc == "arms") {
            img.drawSprite("armsBig", 260 - 34, 140 - 42, 80, 80, 3, player.figure.arms.offset);
            img.drawSprite("armsBig", 260 - 50, 140 - 34, 80, 80, 3, player.figure.arms.offset);
            img.drawSprite("armsBig", 640 - 50, 140 - 42, 80, 80, 5, BodyParts.arms[this.choicePart].offset);
            img.drawSprite("armsBig", 640 - 34, 140 - 34, 80, 80, 5, BodyParts.arms[this.choicePart].offset);

        } else if(this.choiceLoc == "legs") {
            img.drawSprite("legsBig", 260 - 34, 140 - 50, 80, 80, 3, player.figure.legs.offset);
            img.drawSprite("legsBig", 260 - 50, 140 - 42, 80, 80, 3, player.figure.legs.offset);
            img.drawSprite("legsBig", 640 - 50, 140 - 50, 80, 80, 5, BodyParts.legs[this.choicePart].offset);
            img.drawSprite("legsBig", 640 - 34, 140 - 42, 80, 80, 5, BodyParts.legs[this.choicePart].offset);

        }

    };

}