function PreloadingManager() {

    this.soundManagerPreloader;
    this.imagePreloader;
    this.soundPreloader;
    this.pixelFontPreloader;
    this.webFontPreloader;


    this.preload = function() {

        this.soundManagerPreloader = new Preloader();
        this.imagePreloader = new Preloader();
        this.soundPreloader = new Preloader();
        this.pixelFontPreloader = new Preloader();
        this.webFontPreloader = new Preloader();

        this.soundManagerPreloader.setEndCallback(function() {
            preloadingManager.soundPreloader.loadSounds(resources.sounds);
        });
        this.soundManagerPreloader.loadSoundManager();

        this.imagePreloader.setEndCallback(function() {
            preloadingManager.pixelFontPreloader.loadPixelFonts(resources.pixelFonts);
        });
        this.imagePreloader.loadImages(resources.images);

        this.webFontPreloader.loadWebFonts(resources.webFonts);
    };


    this.customPreload = function() {

        ImageProcessing.pixelate("tilesTemp", "tiles", 2);

        ImageProcessing.removeTransparent("headsTemp", "headsTemp2");
        ImageProcessing.pixelate("headsTemp2", "heads", 2);
        ImageProcessing.pixelate("headsTemp2", "headsBig", 4);

        ImageProcessing.removeTransparent("bodiesTemp", "bodiesTemp2");
        ImageProcessing.pixelate("bodiesTemp2", "bodies", 2);
        ImageProcessing.pixelate("bodiesTemp2", "bodiesBig", 4);

        ImageProcessing.removeTransparent("armsTemp", "armsTemp2");
        ImageProcessing.pixelate("armsTemp2", "arms", 2);
        ImageProcessing.pixelate("armsTemp2", "armsBig", 4);

        ImageProcessing.removeTransparent("legsTemp", "legsTemp2");
        ImageProcessing.pixelate("legsTemp2", "legs", 2);
        ImageProcessing.pixelate("legsTemp2", "legsBig", 4);

        ImageProcessing.pixelate("mobShadowTemp", "mobShadow", 2);
        ImageProcessing.pixelate("liquidTemp", "liquid", 2);
        ImageProcessing.pixelate("pathTemp", "path", 2);
        ImageProcessing.pixelate("objectsTemp", "objects", 2);
        ImageProcessing.pixelate("effectsTemp", "effects", 2);

        var borderCanvas = createCanvas(23 * 64, 20);
        var borderC = getContext(borderCanvas);

        for(var i = 0; i < 64; i++) {
            if(i % 2 >= 1) {
                borderC.drawImage(img.get("borderTemp"), 0, 0, 23, 20, 23 * i, 0, 23, 20);
            }
            if(i % 4 >= 2) {
                borderC.drawImage(img.get("borderTemp"), 0, 20, 23, 20, 23 * i, 0, 23, 20);
            }
            if(i % 8 >= 4) {
                borderC.drawImage(img.get("borderTemp"), 0, 40, 23, 20, 23 * i, 0, 23, 20);
            }
            if(i % 16 >= 8) {
                borderC.drawImage(img.get("borderTemp"), 0, 60, 23, 20, 23 * i, 0, 23, 20);
            }
            if(i % 32 >= 16) {
                borderC.drawImage(img.get("borderTemp"), 0, 80, 23, 20, 23 * i, 0, 23, 20);
            }
            if(i % 64 >= 32) {
                borderC.drawImage(img.get("borderTemp"), 0, 100, 23, 20, 23 * i, 0, 23, 20);
            }
        }

        img.add("borderTemp2", borderCanvas);
        ImageProcessing.pixelate("borderTemp2", "borderTemp3", 2);
        ImageProcessing.setOpacity("borderTemp3", "border", 0.5);
    };

}